admin/config/routes.rb
Spree::Core::Engine.add_routes do
  namespace :admin, path: Spree.admin_path do
    # product catalog
    resources :properties, except: :show
    resources :option_types, except: :show do
      resources :option_values, only: [:update]
    end
    resources :products do
      collection do
        get :select_options, defaults: { format: :json }
        post :search
        get :bulk_modal
        put :bulk_status_update
        put :bulk_add_to_taxons
        put :bulk_remove_from_taxons
        put :bulk_add_tags
        put :bulk_remove_tags
      end
      member do
        post :clone
      end
      resources :variants, only: [:edit, :update, :destroy]
      resources :digital_assets, except: [:show]
    end
    # variant search
    post 'variants/search'
    get 'variants/search', defaults: { format: :json }
    # stock
    resources :stock_items, only: [:index, :update, :destroy]
    resources :stock_transfers, except: [:edit, :update]
    # taxonomies and taxons
    resources :taxonomies do
      resources :taxons do
        member do
          put :reposition
        end
      end
    end
    resources :taxons, except: [:show] do |_taxon|
      resources :classifications, only: %i[index new create update destroy]
    end
    get '/taxons/select_options' => 'taxons#select_options', as: :taxons_select_options, defaults: { format: :json }

    # media library
    resources :assets, only: [:create, :edit, :update, :destroy] do
      collection do
        delete :bulk_destroy
      end
    end

    # orders
    resources :checkouts, only: %i[index]
    resources :orders, only: [:index, :edit, :create] do
      member do
        post :resend
        put :cancel
      end
      resource :shipping_address, except: [:index, :show], controller: 'orders/shipping_address'
      resource :billing_address, except: [:index, :show], controller: 'orders/billing_address'
      resource :contact_information, only: [:edit, :update], controller: 'orders/contact_information'
      resource :user, except: [:edit, :show, :index], controller: 'orders/user'
      resources :shipments, only: [:edit, :update, :create], controller: 'shipments' do
        member do
          post :ship
          get :split
          post :transfer
        end
      end
      resources :line_items, except: :show
      resources :customer_returns, except: [:index, :destroy], controller: 'orders/customer_returns'
      resources :return_authorizations, except: [:index, :destroy], controller: 'orders/return_authorizations'
      resources :payments, except: [:index, :show] do
        member do
          put :capture
          put :void
        end
        resources :refunds, only: [:new, :create, :edit, :update]
      end
      resources :payment_links, only: [:create], controller: 'orders/payment_links'
      resources :reimbursements, except: [:destroy, :index] do
        member do
          post :perform
        end
      end
    end

    # customers
    resources :users do
      resources :store_credits
      resources :orders, only: [:index]
      resources :checkouts, only: [:index]

      collection do
        get :bulk_modal
        post :bulk_add_tags
        post :bulk_remove_tags
      end
    end

    resources :addresses, except: [:index, :show]

    # promotions
    resources :promotions do
      member do
        post :clone
      end
      resources :promotion_actions, as: :actions, except: [:index, :show]
      resources :promotion_rules, as: :rules, except: [:index, :show]
      resources :coupon_codes, only: :index
    end
    get 'promotion_rules/option_values_search', defaults: { format: :json }

    # returns
    resources :return_authorizations, only: [:index, :destroy] do
      member do
        patch :cancel
      end
    end
    resources :customer_returns, only: :index
    resources :return_items, only: [:update]

    # translations
    resources :translations, only: [:edit, :update], path: '/translations/:resource_type'

    # audit log
    resources :exports, only: [:index, :new, :create, :show]

    # reporting
    resources :reports, only: [:index, :new, :create, :show]

    # profile settings
    resource :profile, controller: 'profile', only: %i[edit update]

    # store settings
    resource :store, only: [:edit, :update], controller: 'stores' do
      # needed for the getting started set customer support email step
      member do
        get :edit_emails
      end
    end
    # setting up a new store
    resources :stores, only: [:new, :create]
    resources :payment_methods, except: :show
    resources :shipping_methods, except: :show
    resources :shipping_categories, except: :show
    resources :store_credit_categories
    resources :tax_rates, except: :show
    resources :tax_categories, except: :show
    resources :reimbursement_types
    resources :refund_reasons, except: :show
    resources :return_authorization_reasons, except: :show
    resources :zones
    resources :stock_locations, except: :show do
      member do
        put :mark_as_default
      end
    end
    resources :custom_domains, except: :show

    # storefront / page builder
    resource :storefront, only: [:edit, :update], controller: :storefront
    resources :themes, except: [:new, :show] do
      member do
        put :update_with_page
        put :publish
        post :clone
      end
      resources :sections, controller: 'page_sections', only: %i[new create] do
        member do
          patch :move_higher
          patch :move_lower
        end
      end
    end
    resources :pages, except: [:show] do
      resources :sections, controller: 'page_sections', only: %i[new create] do
        member do
          patch :move_higher
          patch :move_lower
        end
      end
    end
    resources :page_sections, only: %i[edit update destroy] do
      member do
        patch :restore_design_settings_to_defaults
      end

      resources :blocks, controller: 'page_blocks' do
        member do
          patch :move_higher
          patch :move_lower
        end

        resources :links, controller: 'page_links', only: [:create]
      end
      resources :links, controller: 'page_links', only: [:create]
    end
    resources :page_links, only: [:edit, :update, :destroy]

    resources :posts do
      collection do
        get :select_options, defaults: { format: :json }
      end
    end
    resources :post_categories

    # account management
    resources :roles, except: :show

    # Action Text
    namespace :action_text do
      resources :video_embeds, only: [:create, :destroy]
    end

    # developer tools
    resources :oauth_applications
    resources :webhooks_subscribers

    # errors
    get '/forbidden', to: 'errors#forbidden', as: :forbidden

    # dashboard
    resource :dashboard, controller: 'dashboard'
    get '/dashboard/analytics', to: 'dashboard#analytics', as: :dashboard_analytics
    get '/getting-started', to: 'dashboard#getting_started', as: :getting_started

    root to: 'dashboard#show'
  end

  get Spree.admin_path, to: 'admin/dashboard#show', as: :admin
end

admin/app/helpers/spree/admin/page_builder_helper.rb
module Spree
  module Admin
    module PageBuilderHelper
      def system_fonts_list
        ['Sans-serif', 'Serif', 'Mono']
      end

      def google_fonts_list
        ['Abel', 'Abril Fatface', 'Alegreya', 'Alegreya Sans', 'Alice', 'Amiri', 'Anonymous Pro', 'Arapey', 'Archivo', 'Archivo Narrow',
         'Arimo', 'Armata', 'Arvo', 'Asap', 'Assistant', 'Asul', 'Bitter', 'Cabin', 'Cardo', 'Catamaran', 'Chivo', 'Cormorant',
         'Crimson Text', 'DM Sans', 'Domine', 'Dosis', 'Eczar', 'Figtree', 'Fira Sans', 'Fjalla One', 'Glegoo', 'IBM Plex Sans', 'Inconsolata',
         'Inknut Antiqua', 'Inter', 'Josefin Sans', 'Josefin Slab', 'Kalam', 'Karla', 'Kreon', 'Lato', 'Libre Baskerville',
         'Libre Franklin', 'Lobster', 'Lobster Two', 'Lora', 'Maven Pro', 'Megrim', 'Merriweather Sans', 'Montserrat',
         'Mouse Memoirs', 'Muli', 'Neuton', 'News Cycle', 'Nobile', 'Noticia Text', 'Noto Serif', 'Nunito', 'Nunito Sans',
         'Old Standard TT', 'Open Sans', 'Oswald', 'Ovo', 'Oxygen', 'PT Mono', 'PT Sans', 'PT Sans Narrow', 'PT Serif',
         'Pacifico', 'Playball', 'Playfair Display', 'Poppins', 'Prata', 'Prompt', 'Quattrocento', 'Quattrocento Sans',
         'Questrial', 'Quicksand', 'Rajdhani', 'Raleway', 'Righteous', 'Roboto', 'Roboto Condensed', 'Roboto Mono', 'Roboto Slab',
         'Rubik', 'Shadows Into Light', 'Slabo 13px', 'Slabo 27px', 'Smooch', 'Source Code Pro', 'Source Sans Pro', 'Space Mono',
         'Syne', 'Tenor Sans', 'Tinos', 'Titillium Web', 'Ubuntu', 'Unica One', 'Unna', 'Varela', 'Varela Round', 'Vidaloka',
         'Volkhov', 'Vollkorn', 'Work Sans']
      end

      def color_palettes
        [
          {
            primary_color: '#1e4bd1',
            text_color: '#000000',
            border_color: '#d1d5db',
            button_text_color: '#ffffff',
            background_color: '#F9FAFB'
          },
          {
            primary_color: '#e63946',
            text_color: '#1d3557',
            border_color: '#a8dadc',
            button_text_color: '#ffffff',
            background_color: '#f1faee'
          },
          {
            primary_color: '#264653',
            text_color: '#060C0E',
            border_color: '#2a9d8f',
            button_text_color: '#ffffff',
            background_color: '#e9c46a'
          },
          {
            primary_color: '#606c38',
            text_color: '#283618',
            border_color: '#dda15e',
            button_text_color: '#ffffff',
            background_color: '#fefae0'
          },
          {
            primary_color: '#FF961F',
            text_color: '#023047',
            border_color: '#219EBC',
            button_text_color: '#FFEEDA',
            background_color: '#DEF0F7'
          },
          {
            primary_color: '#181CF1',
            text_color: '#011627',
            border_color: '#7678ED',
            button_text_color: '#FFFFFF',
            background_color: '#FFF5D6'
          }
        ]
      end

      def color_palette_active?(color_palette)
        @theme_preview&.primary_color&.downcase == color_palette[:primary_color].downcase &&
          @theme_preview&.text_color&.downcase == color_palette[:text_color].downcase &&
          @theme_preview&.border_color&.downcase == color_palette[:border_color].downcase &&
          @theme_preview&.button_text_color&.downcase == color_palette[:button_text_color].downcase &&
          @theme_preview&.background_color&.downcase == color_palette[:background_color].downcase
      end

      def all_fonts_options
        @all_fonts_options ||= system_fonts_list + google_fonts_list
      end

      def all_linkable_pages
        @all_linkable_pages ||= Spree::Page.
                                linkable.
                                without_previews.
                                where(pageable: [@theme, current_store]).
                                map { |page| [page.display_name, page.id] }
      end

      def all_linkable_policies
        @all_linkable_policies = [
          current_store.customer_privacy_policy,
          current_store.customer_terms_of_service,
          current_store.customer_returns_policy,
          current_store.customer_shipping_policy
        ].compact.map { |policy| [policy.name.humanize, policy.id] }
      end

      def refresh_theme_preview(section = nil, block = nil)
        reload_params = section.present? ? "{ frame: 'section-#{section.id}' }" : "{ action: 'replace' }"

        editor_id = if block.present?
                      "block-#{block.id}"
                    elsif section.present?
                      "section-#{section.id}"
                    end

        turbo_stream.replace :iframe_preview_scripts do
          turbo_frame_tag :iframe_preview_scripts do
            javascript_tag do
              raw <<~JS
                document.getElementById('pageLivePreview').contentWindow.window.Turbo.visit(
                  document.getElementById('page-builder').dataset.pageBuilderPreviewUrlValue + '&editor_id=#{editor_id}',
                  #{reload_params}
                )
              JS
            end
          end
        end
      end

      def page_preview_url
        preview_url = @page.preview_url(@theme_preview, @page_preview)
        return if preview_url.blank?

        "#{preview_url}&page_builder=true"
      end
    end
  end
end

admin/app/views/spree/admin/page_builder/_add_block.html.erb
<%= form_for section.blocks.new, url: spree.admin_page_section_blocks_path(section), html: { class: 'list-group-item sidebar-page-block px-0 py-0 border-0 rounded'}, data: { controller: 'block-form', block_form_target: :form } do |f| %>
  <%= f.hidden_field :type, data: { block_form_target: 'type' } %>

  <button class="btn btn-sm btn-link d-flex-inline" data-toggle="dropdown">
    <%= icon("circle-plus") %>
    Add block
  </button>
  <div class="dropdown-menu p-1">
    <% section.available_blocks_to_add.each do |block_class| %>
      <a href="#" class="dropdown-item btn-sm"
          data-action="click->block-form#addBlock"
        data-block-form-type-param="<%= block_class %>"
        >
        <% block_instance = block_class.new %>
        <%= icon block_instance.icon_name, height: 18, class: 'mr-2' if block_class.new.icon_name.present? %>
        <%= block_instance.display_name.presence || block_class.to_s.demodulize.titleize %>
      </a>
    <% end %>
  </div>
<% end %>

admin/app/views/spree/admin/page_builder/_color_palette.html.erb
<% active ||= false %>
<div
  data-action="click->color-palette#selectPalette"
  data-color-palette-primary-color-param="<%= primary_color %>"
  data-color-palette-text-color-param="<%= text_color %>"
  data-color-palette-button-text-color-param="<%= button_text_color %>"
  data-color-palette-border-color-param="<%= border_color %>"
  data-color-palette-background-color-param="<%= background_color %>"
  class="mb-3 d-block w-100 rounded overflow-hidden border cursor-pointer <% if active %>border-2 border-primary<% end %>" style="height: 40px">
  <div class="row mx-0 h-100">
    <div class="col" style="background-color: <%= primary_color %>"></div>
    <div class="col" style="background-color: <%= text_color %>"></div>
    <div class="col" style="background-color: <%= button_text_color %>"></div>
    <div class="col" style="background-color: <%= border_color %>"></div>
    <div class="col" style="background-color: <%= background_color %>"></div>
  </div>
</div>

admin/app/views/spree/admin/page_builder/_color_picker.html.erb
<% color_picker_value ||= value || @theme_preview&.try(:send, field) %>

<div
  class="mb-4 form-group"
  data-controller="color-picker"
  data-color-picker-clear-value="<%= defined?(clear) ? clear : false %>"
  data-color-picker-default-color-value="<%= color_picker_value %>">
  <div class="d-flex align-items-center">
    <%= f.hidden_field field, class: 'form-control mr-2', data: {
      'color-picker-target': 'input',
      'color-palette-target': field.to_s.camelize(:lower),
      action: action,
    }, value: value %>
    <div>
      <label class="mb-0"><%= label %></label>
      <br />
      <span data-color-picker-target="value" class="text-muted">
        <%= color_picker_value&.upcase || Spree.t('admin.page_builder.not_set') %>
      </span>
    </div>
    <div class="ml-auto d-flex align-items-center" style="width:40px">
      <div data-color-picker-target="picker" class="border d-inline-block rounded-circle <% unless color_picker_value.present? %>checkered-background<% end %>" style="height: 40px;width: 40px; background-color: <%= color_picker_value %>;">
      </div>
    </div>
  </div>
</div>

admin/app/views/spree/admin/page_builder/_header.html.erb
<header id="page-builder-header" class="fixed-top p-0 bg-light border-bottom" style="z-index: 1031">
  <nav class="navbar navbar-expand-lg w-100 p-0">
    <%= link_to spree.admin_themes_path, class: 'btn hover-gray rounded-0 border-left-0 border-top-0 border-bottom-0 d-none d-lg-flex px-3 border-right', title: 'Go back to dashboard' do %>
      <%= icon('x', class: 'mr-0 text-muted font-size-lg') %>
    <% end %>
    <div class="px-3">
      <span class="text-muted mr-1">Theme:</span>
      <strong class="mr-1"><%= @theme.name %></strong>
      &nbsp;
      <% if @theme.default? %>
        <span class="badge badge-success">
          <%= icon('check') %>
          Live
        </span>
      <% else %>
        <span class="badge badge-warning">Draft</span>
      <% end %>
    </div>
    <%= render 'spree/admin/page_builder/pages_dropdown' %>

    <ul class="nav nav-pills p-0 m-0" role="tablist">
      <% if @page.custom? %>
        <li class="nav-item h-100 border-right" role="presentation" data-toggle="modal" data-target="#modal">
          <%= link_to_with_icon 'settings', Spree.t(:page_settings), spree.edit_admin_page_path(@page.id), class: 'h-100 btn hover-gray with-tip rounded-0 border-0 shadow-none px-3', data: { turbo_frame: 'dialog_modal' } %>
        </li>
      <% else %>
        <li class="nav-item h-100 border-right" role="presentation">
          <button class="h-100 btn hover-gray active with-tip rounded-0 border-0 shadow-none px-3"
                        title="Page sections"
                        data-toggle="tab"
                        data-target="#sections"
                        type="button"
                        role="tab"
                        aria-controls="sections"
                        aria-selected="true"
                        data-trigger="hover"
                        id="sidebar-icon-page">
            <%= icon 'section', class: 'mr-0' %>
          </button>
        </li>
        <li class="nav-item h-100 border-right" role="presentation">
          <button class="h-100 btn hover-gray with-tip rounded-0 border-0 shadow-none px-3"
                  title="Theme"
                  data-toggle="tab"
                  data-target="#colors"
                  type="button"
                  role="tab"
                  aria-controls="theme"
                  aria-selected="false"
                  data-trigger="hover"
                  id="sidebar-icon-colors">
            <%= icon 'palette', class: 'mr-0' %>
          </button>
        </li>
        <li class="nav-item h-100 border-right" role="presentation">
          <button class="h-100 btn hover-gray with-tip rounded-0 border-0 shadow-none px-3"
                title="Fonts"
                type="button"
                data-toggle="tab"
                data-target="#fonts"
                type="button"
                role="tab"
                aria-controls="fonts"
                aria-selected="false"
                data-trigger="hover"
                id="sidebar-icon-fonts">
            <%= icon 'typography', class: 'mr-0' %>
          </button>
        </li>
      <% end %>
    </ul>
    <button class="btn with-tip ml-auto border-left px-3 text-black" type="button"
            title="Mobile"
            data-trigger="hover"
            data-action="click->page-builder#setResponsiveBreakpoint"
            data-page-builder-target="mobileButton"
            data-page-builder-breakpoint-param="mobile">
      <%= icon 'device-mobile', class: 'mr-0' %>
    </button>
    <button class="btn active with-tip border-right px-3 text-black" type="button" title="Desktop"
            data-action="click->page-builder#setResponsiveBreakpoint"
            data-page-builder-breakpoint-param="desktop"
            data-trigger="hover"
            data-page-builder-target="desktopButton">
      <%= icon 'device-laptop', class: 'mr-0' %>
    </button>

    <%= link_to_with_icon 'eye.svg', Spree.t(:preview), @page.preview_url(@theme_preview, @page_preview), class: 'btn hover-gray d-none d-lg-flex align-items-center border-left', target: '_blank' %>

    <%= button_tag class: 'btn btn-primary px-3 d-flex justify-content-center shadow-none' do %>
      <span class="show-when-enabled">
        <%= @theme.default? ? Spree.t('actions.publish') : Spree.t('actions.save') %>
      </span>
      <span class="show-when-disabled">
        <div class="spinner-border" role="status" style="width: 18px; height: 18px">
          <span class="sr-only"><%= Spree.t(:loading) %>...</span>
        </div>
      </span>
    <% end %>
  </nav>
</header>

admin/app/views/spree/admin/page_builder/_labeled_range_input.html.erb
<div class="mb-4 form-group">
  <div data-controller="better-slider">
    <label><%= _label %>: <span data-better-slider-target="currentValueLabel"></span><%= unit %></label>
    <div class="flex flex-row w-full">
      <span class="mr-2"><%= min %><%= unit %></span>
      <%= f.range_field field, class: "custom-range", min: min, max: max, step: 1, data: {'better-slider-target': 'rangeInput', action: 'change->auto-submit#submit'} %>
      <span class="ml-2"><%= max %><%= unit  %></span>
    </div>
  </div>
</div>

admin/app/views/spree/admin/page_builder/_pages_dropdown.html.erb
<% if @page.custom? %>
  <div class="d-flex justify-content-center h-100 align-items-center px-3">
    <p class="mb-0 font-weight-bold"><%= truncate(@page.display_name, length: 150) %></p>
  </div>
<% else %>
  <div class="dropdown h-100" id="pages_dropdown">
    <button class="btn hover-gray border-bottom-0 border-top-0 rounded-0 border-left border-right d-flex align-items-center justify-content-between h-100" type="button" data-toggle="dropdown" aria-expanded="false">
      <span class="d-flex align-items-center pr-5">
        <%= icon @page.icon_name, class: 'mr-2' %>
        <%= @page.display_name %>
      </span>
      <%= icon 'selector', class: 'mr-0 ml-2 mb-0 text-muted' %>
    </button>
    <div class="dropdown-menu" style="min-width: 300px">
      <% @theme.pages.standard.order(name: :asc).find_all(&:customizable?).each do |page| %>
        <%= active_link_to spree.edit_admin_theme_path(@theme, theme_preview_id: @theme_preview.id, page_id: page.id), class: 'dropdown-item', active: @page == page do %>
          <%= icon page.icon_name, class: 'mr-2' %>
          <%= page.display_name %>
        <% end %>
      <% end %>
    </div>
  </div>
<% end %>

admin/app/views/spree/admin/page_builder/_range_input.html.erb
<% label ||= nil %>
<% label_for_min_value ||= nil %>
<% action ||= 'change->auto-submit#submit' %>
<div class="mb-4 form-group">
  <div data-controller="better-slider" data-better-slider-label-for-min-value="<%= label_for_min_value %>" data-better-slider-unit-value="<%= unit %>">
    <label><%= label.presence || field.to_s.humanize %></label>
    <div class="flex flex-row w-full">
      <%= f.range_field field, class: "custom-range", min: min, max: max, step: 1, data: {'better-slider-target': 'rangeInput', action: action} %>
    </div>
    <span data-better-slider-target="currentValueLabel"></span>
  </div>
</div>

admin/app/views/spree/admin/page_builder/_sidebar.html.erb
<aside id="page-builder-sidebar" class="border-right fixed-top h-100 overflow-auto pb-5 right-sidebar">
  <div class="tab-content mb5">
    <div class="tab-pane fade show active" id="sections" role="tabpanel" aria-labelledby="sidebar-icon-page">
      <%= render 'spree/admin/page_builder/sidebar_sections' %>
      <%= render 'spree/admin/page_builder/sidebar_sections_toolbar' %>
    </div>
    <div class="tab-pane fade" role="tabpanel" aria-labelledby="sidebar-icon-colors" id="colors">
      <%= render 'spree/admin/page_builder/sidebar_colors' %>
    </div>
    <div class="tab-pane fade" role="tabpanel" aria-labelledby="sidebar-icon-fonts" id="fonts">
      <%= render 'spree/admin/page_builder/sidebar_fonts' %>
    </div>
  </div>
</aside>

admin/app/views/spree/admin/page_builder/_sidebar_block.html.erb
<% if block.persisted? %>
  <%= turbo_frame_tag dom_id(block), class: 'list-group-item sidebar-page-block px-0 py-0 border-0 rounded',
                                     data: {
                                       action: 'mouseover->page-builder#toggleHighlightElement mouseout->page-builder#toggleHighlightElement',
                                       page_builder_editor_id_param: "block-#{block.id}",
                                       sortable_update_url: spree.admin_page_section_block_path(block.section, block, format: :turbo_stream)
                                     } do %>
    <div class="d-flex align-items-center justify-content-between sidebar-block-title p-1 rounded-sm">
      <div class="d-flex align-items-center flex-fill">
        <%= icon "#{block.icon_name}", class: 'mr-2' if block.icon_name.present? %>
        <%= link_to block.display_name, edit_admin_page_section_block_path(block.section, block),
                    class: 'block-edit-link flex-fill text-dark',
                    data: {
                      turbo_frame: :page_sidebar,
                      action: 'click->page-builder#makeOverlayActive',
                      page_builder_editor_id_param: "block-#{block.id}"
                    }
        %>
      </div>
      <div class="d-flex align-items-center d-none">
        <% if block.section.can_sort_blocks? %>
          <button class="btn btn-sm pr-0 handle hover-gray-200 h-100 mr-1 px-1 handle-block">
            <%= icon('grip-vertical', class: 'mr-0') %>
          </button>
        <% end %>
      </div>
    </div>
  <% end %>
<% end %>

admin/app/views/spree/admin/page_builder/_sidebar_section.html.erb
<% if section.persisted? %>
  <%= turbo_frame_tag dom_id(section), class: 'list-group-item py-0 border-0 sidebar-page-section draggable rounded-sm',
                                       data: { sortable_update_url: spree.admin_page_section_path(section, format: :turbo_stream) } do %>
    <div class="d-flex align-items-center justify-content-between sidebar-section-title py-1 rounded"
         data-action="mouseover->page-builder#toggleHighlightElement mouseout->page-builder#toggleHighlightElement"
      data-page-builder-editor-id-param="section-<%= section.id %>">
      <div class="d-flex align-items-center flex-fill py-1 px-2">
        <%= icon("#{section.icon_name}", height: 18, class: 'mr-2') if section.icon_name.present? %>
        <%= link_to section.display_name, spree.edit_admin_page_section_path(section),
            class: 'section-edit-link flex-fill font-weight-bold text-dark',
            data: {
              turbo_frame: :page_sidebar,
              action: 'click->page-builder#makeOverlayActive',
              page_builder_editor_id_param: "section-#{section.id}"
            }
        %>
      </div>
      <div class="d-flex align-items-center d-none">
        <% if section.can_be_sorted? %>
          <button class="btn btn-sm pr-0 handle hover-gray-200 h-100 mr-1 px-1 handle-section">
            <%= icon('grip-vertical', class: 'mr-0') %>
          </button>
        <% end %>
      </div>
    </div>
    <% if section.blocks_available?  %>
      <div class="d-flex flex-column ml-1 mb-2">
        <%= turbo_frame_tag [:blocks, section.id].join('_'), class: 'list-group-flush collapse show' do %>
          <% if section.can_sort_blocks? %>
          <div data-controller="sortable"
            data-sortable-handle-value=".handle-block"
            data-sortable-resource-name-value="page_block"
            data-sortable-response-kind-value="turbo-stream">
          <% else %>
          <div>
          <% end %>
            <%= render partial: 'spree/admin/page_builder/sidebar_block', collection: section.blocks.includes(:rich_text_text), as: :block %>
          </div>
        <% end %>
        <% if section.available_blocks_to_add.any? %>
          <%= render 'spree/admin/page_builder/add_block', section: section %>
        <% end %>
      </div>
    <% end %>
  <% end %>
<% end %>

admin/app/views/spree/admin/page_builder/_sidebar_sections.html.erb
<%= turbo_frame_tag :page_sidebar do %>
<div class="d-none d-md-block">
  <h6 class="p-3 bg-light border-bottom sticky-top border-bottom text-uppercase text-muted">Page sections</h6>
  <% if @page_preview.layout_sections? %>
    <div class="list-group-flush border-bottom mb-1 pb-2">
      <%= render collection: @theme_preview.sections.find_all { |s| s.role == 'header' }, partial: 'spree/admin/page_builder/sidebar_section', as: :section  %>
    </div>
  <% end %>
  <div id="page-sections-list" class="list-group-flush py-2">
    <div data-controller="sortable"
         data-sortable-handle-value=".handle-section"
         data-sortable-resource-name-value="page_section"
         data-sortable-response-kind-value="turbo-stream">
      <%= render partial: 'spree/admin/page_builder/sidebar_section', 
                 collection: @page_preview.sections.includes(:blocks),
                 as: :section  %>
    </div>
  </div>
  <div class="px-3">
    <%= link_to_with_icon 'new-section', Spree.t(:add_section), spree.new_admin_page_section_path(@page_preview), class: 'btn btn-primary rounded-pill text-uppercase w-100 my-2 py-2' %>
  </div>
  <% if @page_preview.layout_sections? %>
    <div class="list-group-flush border-top py-2">
      <%= render collection: @theme_preview.sections.find_all { |s| s.role == 'footer' }, partial: 'spree/admin/page_builder/sidebar_section', as: :section  %>
    </div>
  <% end %>
</div>
<div class="d-flex justify-content-center pt-5 d-md-none align-items-center">
  <div class="spinner-border" role="status">
  </div>
  <p class="ml-2 m-0"><%= Spree.t(:loading) %>...</p>
</div>
<% end if @page_preview.present? %>